package DLMListener;

import DLMListener.DLMListener;
import DLMListener.EventDispatcher;
import MoveNClick.ClickEvent;
import MoveNClick.MoveEvent;
import MoveNClick.PressEvent;
import MoveNClick.ReleaseEvent;
import MoveNClick.ZoomEvent;
import OxygenGraphics.O2Panel;
import OxygenGraphics.O2Window;
import TouchRecognizer.BlobDetector;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JLabel;

/**
 *
 * @author gioele
 */
public class Calibration extends O2Window implements DLMListener, MouseListener
{
	private JLabel info;
	private int minX, minY, maxX, maxY;
        private O2Panel calibrationPanel;
        private EventDispatcher dispatcher;
        private DLMApplet app;

	public Calibration(DLMApplet app)
	{
            this.app = app;
		int screenX = Toolkit.getDefaultToolkit().getScreenSize().width;
		int screenY = Toolkit.getDefaultToolkit().getScreenSize().height;

		// fullscreen
		setSize(screenX, screenY);

		calibrationPanel = new O2Panel();
		calibrationPanel.setLayout(null);
		calibrationPanel.setSize(screenX, screenY);
		calibrationPanel.setLocation(0,0);
		calibrationPanel.addDLMListener(this);
		calibrationPanel.addMouseListener(this);

		setContentPane(calibrationPanel);

		info = new JLabel("Clicca sullo schermo in alto a destra");
		info.setSize(300, 100);
		info.setLocation(screenX / 2 - info.getWidth() / 2,
						screenY / 2 - info.getHeight() / 2);
		calibrationPanel.add(info);

		minX = minY = maxX = maxY = -1;

		setVisible(true);
	}

	public void pressEvent(PressEvent e) {}

	public void moveEvent(MoveEvent e) {}

	public void releaseEvent(ReleaseEvent e) {}

	public void clickEvent(ClickEvent e)
	{
		if(maxX == -1 || minY == -1)
		{
			maxX = e.getX();
			minY = e.getY();
			
			info.setText("Clicca sullo schermo in basso a sinistra");
			getContentPane().repaint();
		}
		else
		{
			minX = e.getX();
			maxY = e.getY();

			// settiamo le soglie adattandole alla risoluzione
			maxX = (int) ((maxX / (double) Toolkit.getDefaultToolkit().getScreenSize().width)
					* BlobDetector.getWidth());
			maxY = (int) ((maxY / (double) Toolkit.getDefaultToolkit().getScreenSize().height)
					* BlobDetector.getHeight());
			minX = (int) ((minX / (double) Toolkit.getDefaultToolkit().getScreenSize().width)
					* BlobDetector.getWidth());
			minY = (int) ((minY / (double) Toolkit.getDefaultToolkit().getScreenSize().height)
					* BlobDetector.getHeight());

			BlobDetector.setMaxX(maxX);
			BlobDetector.setMaxY(maxY);
			BlobDetector.setMinX(minX);
			BlobDetector.setMinY(minY);

			// DEBUG
			System.out.println("Margini attuali:");
			System.out.println("\tX: " + minX + " -> " + maxX);
			System.out.println("\tY: " + minY + " -> " + maxY);
			
			calibrationPanel.removeDLMListener();
			dispose();
                        app.runApp();
		}
	}

	public void zoomEvent(ZoomEvent e) {}

	public void mouseClicked(MouseEvent e)
	{
		if(maxX == -1 || minY == -1)
		{
			maxX = e.getXOnScreen();
			minY = e.getYOnScreen();

			info.setText("Clicca sullo schermo in basso a sinistra");
			getContentPane().repaint();
		}
		else
		{
			minX = e.getXOnScreen();
			maxY = e.getYOnScreen();

			// settiamo le soglie adattandole alla risoluzione
			maxX = (int) ((maxX / (double) Toolkit.getDefaultToolkit().getScreenSize().width)
					* BlobDetector.getWidth());
			maxY = (int) ((maxY / (double) Toolkit.getDefaultToolkit().getScreenSize().height)
					* BlobDetector.getHeight());
			minX = (int) ((minX / (double) Toolkit.getDefaultToolkit().getScreenSize().width)
					* BlobDetector.getWidth());
			minY = (int) ((minY / (double) Toolkit.getDefaultToolkit().getScreenSize().height)
					* BlobDetector.getHeight());

			BlobDetector.setMaxX(maxX);
			BlobDetector.setMaxY(maxY);
			BlobDetector.setMinX(minX);
			BlobDetector.setMinY(minY);

			// DEBUG
			System.out.println("Margini attuali:");
			System.out.println("\tX: " + minX + " -> " + maxX);
			System.out.println("\tY: " + minY + " -> " + maxY);

			removeDLMListener();
			dispose();
                        app.runApp();
		}
	}
	
	public void mousePressed(MouseEvent e) {}

	public void mouseReleased(MouseEvent e) {}

	public void mouseEntered(MouseEvent e) {}

	public void mouseExited(MouseEvent e) {}
}
