package ExampleApp;

import OxygenGraphics.O2Panel;
import java.awt.*;
/**
 *
 * @author amonacch
 */
public class ImagePanel extends O2Panel
{
    // attributi
    private Image img;
    private boolean moveable;

    public ImagePanel(Image img)
    {
        this.setImage(img);
        this.moveable = false;
    }
    // metodi
    public void setImage(Image i)
    {
        this.img = i;
    }
    public Image getImage()
    {
        return this.img;
    }

    public void moveable()
    {
        this.moveable = true;
        repaint();
    }

    public void unmoveable()
    {
        this.moveable = false;
        repaint();
    }

    public boolean isMoveable()
    {
        return this.moveable;
    }
    
    // scriviamo il metodo di disegno dell'interfaccia grafica
    @Override
    public void paintComponent(Graphics g)
    {
        // disegno il contenuto del pannello
        super.paintComponent(g);
        
        // setto il colore con cui disegnare
        if(this.moveable)
            g.setColor(Color.magenta);
        else
            g.setColor(Color.ORANGE);
        // disegno un rettangolo
        g.fillRect(0, 0, this.getWidth(), this.getHeight());     
        
        // disegno l'immagine
        if(this.img != null)
        {
            g.drawImage(this.img, 2, 2,
                        this.getWidth() - 4,
                        this.getHeight() - 4, this);
            // ho scritto -4 perchè l'immagine inizia a +2 quindi facendo getWidth
            // andrei fuori dallo spazio, devo lasciare 2 anche dall'altra parte
            // quindi 2+2=4
        }
        
    }

    public void moveImage(int deltaX, int deltaY)
    {
        setLocation(getX() + deltaX, getY() + deltaY);
    }
    
    public void zoomImage(double zoom)
    {
        this.setSize((int)(this.getWidth() * zoom), (int)(this.getHeight() * zoom));
        this.repaint();
    }

    
}
