package ExampleApp;

import DLMListener.Calibration;
import DLMListener.DLMApplet;
import OxygenGraphics.O2Button;
import OxygenGraphics.O2Frame;
import java.io.IOException;
import java.awt.*;
import java.io.File;
import java.util.Vector;
import javax.imageio.ImageIO;

public class MainApp extends O2Frame implements DLMApplet
{
    // attributi
    int indice;
    
    O2Button buttonImage;
    O2Listener listener;

    // definisco un contenitore per l'immagine
    Vector<ImagePanel> pannelli;
    
    Vector<Image> immagini;
    
    public MainApp()
    {
        this.indice = 0;
        this.setTitle("First Frame");
        this.setSize(600, 600);
        
        // inizializzo il pannello per l'immagine
        this.pannelli = new Vector<ImagePanel>();
        
        // prelevo il pannello di contenuto
        Container pane = this.getContentPane();
        
        // setto il mio layout
        pane.setLayout(null);

        this.buttonImage = new O2Button("Aggiungi una foto");
        this.buttonImage.setSize(100, 50);
        this.buttonImage.setLocation(20, 20);

        pane.add(buttonImage);
   
        // creo un ascoltatore
        // e lo associo agli oggetti
        listener = new O2Listener(this);
        this.buttonImage.addDLMListener(listener);

        loadImages();
    }

    public void addImage()
    {
        ImagePanel panel = new ImagePanel(immagini.elementAt(indice++ % immagini.size()));
        panel.setSize(200, 200);
        panel.setLocation((int)(Math.random() * this.getContentPane().getWidth()), (int)(Math.random() * this.getContentPane().getHeight()));
        this.getContentPane().add(panel);
        panel.repaint();
        panel.addDLMListener(this.listener);

        pannelli.add(panel);
    }

    private void loadImages()
    {
        immagini = new Vector<Image>();

        File dir = new File("image");

        if(dir.isDirectory())
        {
            String[] nomiFile = dir.list();

            for(String nomeFile: nomiFile)
            {
                if(nomeFile.endsWith(".jpg"))
                {
                    try
                    {
                        immagini.add(ImageIO.read(new File(dir, nomeFile)));
                    }
                    catch (IOException ex)
                    {
                        System.out.println(ex);
                    }
                }
            }
        }
        else
            System.out.println("Directory non trovata");
    }

    
    public static void main(String args[])
    {
        new Calibration(new MainApp());
    }

    public void runApp()
    {
        this.setVisible(true);
    }
}
