package ExampleApp;

import DLMListener.DLMListener;
import MoveNClick.ClickEvent;
import MoveNClick.MoveEvent;
import MoveNClick.PressEvent;
import MoveNClick.ReleaseEvent;
import MoveNClick.ZoomEvent;

public class O2Listener implements DLMListener
{
    MainApp frame;
    Boolean fineEvento;

    public O2Listener(MainApp frame)
    {
        this.frame = frame;
        fineEvento = true;
    }

    public void pressEvent(PressEvent e) {
        if(e.getSource() instanceof ImagePanel)
        {
            ImagePanel panel = (ImagePanel) e.getSource();
            panel.moveable();
        }
    }

    public void moveEvent(MoveEvent e)
    {
        if(e.getSource() instanceof ImagePanel)
        {
            ImagePanel panel = (ImagePanel) e.getSource();
            if(panel.isMoveable())
                panel.moveImage(e.getDeltaX(), e.getDeltaY());
        }
    }

    public void releaseEvent(ReleaseEvent e)
    {
        if(e.getSource() instanceof ImagePanel)
        {
            ImagePanel panel = (ImagePanel) e.getSource();
            panel.unmoveable();
        }
    }

    public void clickEvent(ClickEvent e)
    {
        if(e.getSource() == this.frame.buttonImage)
            this.frame.addImage();
        else if(e.getSource() instanceof ImagePanel)
        {
            ImagePanel panel = (ImagePanel) e.getSource();
            panel.unmoveable();
        }

    }

    public void zoomEvent(ZoomEvent e)
    {
        if(e.getSource() instanceof ImagePanel)
            ((ImagePanel) e.getSource()).zoomImage(e.getZoom());

    }
}
