package MoveNClick;

import TouchRecognizer.Point;

/**
 * Evento di tipo Zoom
 * @author dlm
 */
public class ZoomEvent extends Event
{
    // *** ATTRIBUTI ***
    private double zoom;


    // *** METODI ***
    public ZoomEvent(MoveEvent e1, MoveEvent e2)
    {
        double oldDistance = (new Point(e1.x, e1.y)).distance(new Point(e2.x, e2.y));
        double newDistance = (new Point(e1.x + e1.getDeltaX(), e1.y + e1.getDeltaY())).distance
                            (new Point(e2.x + e2.getDeltaX(), e2.y + e2.getDeltaY()));
        zoom = (oldDistance == 0) ? 1 : (newDistance / oldDistance);

        // setta la posizione dello zoom
        this.x = (e1.x + e2.x) / 2;
        this.y = (e1.y + e2.y) / 2;

        // setta la sorgente dello zoom
        this.setSource(e1.getSource());

    }

    public ZoomEvent(PressEvent p1, MoveEvent e1)
    {
        double oldDistance = (new Point(p1.x, p1.y)).distance(new Point(e1.x, e1.y));
        double newDistance = (new Point(p1.x, p1.y)).distance(new Point(e1.x + e1.getDeltaX(), e1.y + e1.getDeltaY()));

        zoom = (oldDistance == 0) ? 1 : (newDistance / oldDistance);

        // setta la posizione dello zoom
        this.x = (p1.x + e1.x) / 2;
        this.y = (p1.y + e1.y) / 2;

        // setta la sorgente dello zoom
        this.setSource(e1.getSource());
    }

    public double getZoom()
    {
        return this.zoom;
    }
}
