// Package
package OxygenGraphics;

// Import
import DLMListener.DLMListener;
import DLMListener.EventDispatcher;
import TouchRecognizer.Point;
import java.awt.Component;
import javax.swing.JFrame;


/**
 *
 * @author dlm
 */
public class O2Frame extends JFrame implements O2Component
{
    public void addDLMListener(DLMListener listener)
    {
        // devo metter l'ascoltatore nel dispatcher
        EventDispatcher disp = EventDispatcher.getIstance();
        disp.addListener(this, listener);
    }

	public void removeDLMListener()
	{
		EventDispatcher.getIstance().removeListener(this);
	}

    public Point getAbsolutePosition()
    {
        return getAbsPosition(this);
    }

    private Point getAbsPosition(Component c)
    {
        Point posizione;
        if(c.getParent() == null)
            posizione = new Point(c.getX(), c.getY());
        else
        {
            Point posPadre = getAbsPosition(c.getParent());

            posizione = new Point(this.getX() + posPadre.getX(), this.getY() + posPadre.getY());
        }

        return posizione;
    }
}
